import os.path
import logging
import kraken.tools.Utils as Utils
from kraken.entrytypes.MetaData import loadMetaData
import kraken.presentation.Query as Query
import kraken.Constants

def description(system, runtime):
    t  = "Gathers the bibtex files from all the entries which have that and\n"
    t += "creates a file named " + kraken.Constants.DEFAULT_BIBTEX_FILE + " suitable as an\n"
    t += "input to bibtex.\n"
    return t

#
#  Execute the command
#
def execute(system, runtime):
    print "Generating Bibtex..."
    metadata = loadMetaData(system, runtime)
    bibtexFile = kraken.Constants.DEFAULT_BIBTEX_FILE 
    FILE = open(bibtexFile, "w+")
    bibtexEntryCount = 0
    for entry in metadata.entries:        
        metadataDir = os.path.join(entry.krakenDirName, entry.directoryName, 
              kraken.Constants.DIRNAME_METADATA)
        bibFilename = os.path.join(metadataDir, kraken.Constants.ENTRY_TYPE_FILE_BIBTEX)
        if not os.path.exists(bibFilename):
           continue
        FILE.write("% Generated from kraken entry " + entry.directoryName + "\n")    
        BIBFILE = open(bibFilename)
        while 1:
            line = BIBFILE.readline()
            if (line == ""):
                BIBFILE.close()
                break
            FILE.write(line)
        FILE.write("\n\n")
        bibtexEntryCount = bibtexEntryCount + 1
    FILE.close()
    print "Generated " + str(bibtexEntryCount) + " entries in file " + bibtexFile
