from rdflib.Namespace import Namespace
import kraken.Constants

# Namespaces typically used in the kraken

# the self description of the class
namespaces = {}
# the RDF namespace
namespaces["rdf"] = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"
# the RDF schema namespace
namespaces["rdfs"] = "http://www.w3.org/2000/01/rdf-schema#"
# the XSD  namespace
namespaces["xsd"] = "http://www.w3.org/2000/10/XMLSchema#"
# the OWL namespace
namespaces["owl"] = "http://www.w3.org/2002/07/owl#"
# the Dublin core 
namespaces["dc"] = "http://purl.org/dc/elements/1.1/"
# the FOAF (friend of a friend) schema 
namespaces["foaf"] = "http://xmlns.com/foaf/0.1/"
# the kraken namespace
namespaces["kraken"] = kraken.Constants.KRAKEN_RDF_URI
# the KRAKEN ontology namespace
namespaces["krakont"] = "http://www.cs.ucf.edu/~lboloni/Programming/KrakenWeb/krakenEntrySchema#"
# the base namespace
namespaces["base"] = "http://www.cs.ucf.edu/~lboloni/Programming/KrakenWeb/krakenEntrySchema"
    
NS_RDF = Namespace(namespaces["rdf"])
NS_RDFS     = Namespace(namespaces["rdfs"])
NS_XSD   = Namespace(namespaces["xsd"])
NS_OWL   = Namespace(namespaces["owl"])
NS_KRAKONT   = Namespace(namespaces["krakont"])
NS_KRAKEN = Namespace(namespaces["kraken"])
NS_DC     = Namespace(namespaces["dc"])
NS_FOAF   = Namespace(namespaces["foaf"])
