import kraken.tools.TextUi as TextUi
from Filters import *
from Rankers import *

def createFilterWithVerify(metadata):
  flt = None
  while 1:  
    if flt == None:
       flt = createFilter()
    md = flt.filterMetaData(metadata)
    print "The filter matches " + str(len(md.entries)) + " entries."
    menuitems = [
       "Accept this filter", 
       "List matching entries", 
       "Create a different filter"
    ]
    choice = TextUi.inputMenu("Enter your choice", menuitems)
    if choice == "Accept this filter":
        return flt
    if choice == "List matching entries":
        for entry in md.entries:
            print entry.getProperty("Title")
    if choice == "Create a different filter":
        flt = None
    
def createRankerWithVerify(metadata):
   ranker = None
   while 1:
       if ranker == None:
           ranker = createRanker()
       md = rankMetaData(metadata, ranker)    
       print "The created ranker is: " + str(ranker) + "\n"
       menuitems = [
          "Accept this ranker",
          "List the entries ranked by this ranker", 
          "Create a different ranker",
       ]
       choice = TextUi.inputMenu("Enter your choice", menuitems)
       if choice == "Accept this ranker":
           return ranker
       if choice == "List the entries ranked by this ranker":
           for entry in md.entries:
              print entry.getProperty("Title")
       if choice == "Create a different ranker":
           ranker = None
        

def createFilter():
   menuitems = [
                "Pass-all filter",
                "Equal", 
                "Contains all", 
                "Contains any", 
                "Comparison", 
                "String matching", 
                "Logical operations"
   ]
   choice = TextUi.inputMenu("Enter your choice", menuitems)
   if choice == "Pass-all filter":
       flt = NoFilter()
       return flt
   if choice == "Equal":
       flt = EqualityFilter()
       flt.propertyName = TextUi.inputString("Property Name")
       flt.filterValue = TextUi.inputString("Value")
       return flt
   if choice == "Contains all":
       flt = ContainsAllFilter()
       flt.propertyName = "keywords"
       flt.filterValue = TextUi.inputSequence("List of keywords")
       print flt.filterValue
       return flt
   if choice == "Contains any":
       flt = ContainsAnyFilter()
       flt.propertyName = "keywords"
       flt.filterValue = TextUi.inputSequence("List of keywords")
       return flt
   print choice + " not supported yet!!!"
       

def createRanker():
    menuitems = ["No ranking",
                 "Limit length",
                 "Reverse ranking", 
                 "Property based ranking", 
                 "Preferred value ranking",
                 "Multilevel ranking",
                 ]
    choice = TextUi.inputMenu("Enter your choice", menuitems)
    if choice == "No ranking":
        return NoRanking()
    if choice == "Reverse ranking":
        ranking = ReverseRanking()
        print "Now, create the ranker which is reversed!!!\n"
        ranking.theRanker = createRanker()
        return ranking
        
    print choice + " not supported yet!!! - returning No Ranking"
    return NoRanking()
    
