from kraken.entrytypes.MetaData import MetaData
import kraken.tools.TextUi as TextUi
import copy
import string
import logging
from Filters import *

class Query:
    
    def __init__(self):
        self.keywordsAll = []
        self.keywordsAny = []
        self.titleContains = None
        self.descriptionContains = None        

    def fillFromRuntime(self, runtime):
        if runtime.selectKeywordsAll != None:
            self.keywordsAll = string.split(runtime.selectKeywordsAll,",")
        if runtime.selectKeywordsAny != None:
            self.keywordsAny = string.split(runtime.selectKeywordsAny,",")
        if runtime.selectTitleContains != None:
            self.titleContains = runtime.selectTitleContains
        if runtime.selectDescriptionContains != None:
            self.descriptionContains = runtime.selectDescriptionContains

    def match(self, entry):
       # keywords all
       if self.keywordsAll != []: 
          for a in self.keywordsAll:
             if not (a in entry.keywords):
                return 0
       # keywords any
       if self.keywordsAny != []:
          passes = 0
          for a in self.keywordsAny:
             if a in entry.keywords:
                passes = 1             
          if not passes: 
             return 0
       # title contains
       #if string.find(entry.title, word) == -1:
       #    return 0
       # description contains
       #if string.find(entry.description, word) == -1:
       #    return 0
       # otherwise, it matches          
       return 1
        
    def filterMetaData(self, metadata):
       temp = MetaData()
       temp.keywords = copy.deepcopy(metadata.keywords)
       for a in metadata.entries:
          if self.match(a):
             print "Appending" + str(a)
             temp.entries.append(copy.deepcopy(a))
       return temp

    def __str__(self):
        t = "Query:"
        t += "\n\tContains all keywords: " + str(self.keywordsAll)
        t += "\n\tContains any of the keywords: " + str(self.keywordsAny)
        t += "\n\tTitle contains: " + str(self.titleContains)
        t += "\n\tDescription contains:" + str(self.descriptionContains)
        return t
        
    def edit(self):
        self.keywordsAll = TextUi.inputSequence("Contains all keywords", self.keywordsAll)
        self.keywordsAny = TextUi.inputSequence("Contains any keywords", self.keywordsAny)
        self.titleContains = TextUi.inputString("Title contains", self.titleContains)
        self.descriptionContains = TextUi.inputString("Description contains", self.descriptionContains)
        print "Result: " + str(self)
        
