import os
import string
import shutil
import copy
import logging

# this is fixing the problem that in windows we don't have readline
if os.name == 'posix': 
    import readline
    haveReadline = 1
else:   
    haveReadline = 0


'''
    Helper function. A relatively sophisticated stuff 
    to allow initilizing the readline stuff with some data
'''        
def inputWithDefault(varname, initvalue=""):
        # this fixes some frequent occurences of editing uninitialized 
        # variables
        if initvalue == None:
           initvalue = ""
        if haveReadline:          
            def __defaultStartupHook():
                readline.insert_text(__currentDefault)        
            __currentDefault = initvalue        
            readline.set_startup_hook(__defaultStartupHook)
            temp = raw_input(varname + " = ")
            readline.set_startup_hook()
        else:
            print varname + " = " + initvalue + "\n\t(<ENTER> to keep)"
            temp = raw_input(varname + " = ")
            if temp == "":
                return initvalue
        return temp
        
def inputString(prompt, initvalue = ""):    
    return inputWithDefault(prompt, initvalue)
    
         
'''
    Helper function. A relatively sophisticated stuff 
    to allow initilizing the readline stuff with some data
'''        
def inputInteger(prompt, initvalue = 0):
     initstring = str(initvalue)
     valuestring = inputWithDefault(prompt, initstring)
     return int(valuestring)

'''
    Helper function. A relatively sophisticated stuff 
    to allow initilizing the readline stuff with some data
'''
def inputSequence(varname, initvalue = [], nsstringlist = []):
    stringlist = copy.copy(nsstringlist)
    stringlist.sort()
    while 1:
        done = 1
        tmp = ""
        for a in initvalue:
            tmp = tmp + a + ","
        tmp = tmp[:-1]
        tmp = inputWithDefault(varname, tmp)
        if tmp != "":
           temp = string.split(tmp, ",")
           temp = map(string.strip, temp)
        else:
           temp = []
        if stringlist != []:
          for a in temp:
             if a not in stringlist:
                 print a + " is not a keyword."
                 print "The list of suggested choices are: " + str(stringlist)
                 if not confirm("Do you want to proceed (Y) or continue editing (N) ?"):
                     done = 0
                     break; 
        if done: return temp
    
'''
   Returns 0 or 1 depending of the confirmation of the question
'''
def confirm(question):
      reply = raw_input(question + " (Y/N) ")
      if reply not in "yY":
          return 0
      return 1            

'''
   Input menu
'''
def inputMenu(prompt, labels, values=None, question = "Enter your selection: ",
   forceSelection = 1):
    print prompt 
    print "\n"
    if values == None: 
        values = labels
    while 1:        
      i = 1
      for a in labels:
         print str(i) + " " + a
         i = i + 1
      print ""
      reply = raw_input(question)
      if not forceSelection and reply == "":
          return None
      try:
        repval = int(reply)
      except:
        logging.warning("Error, enter a number")
        continue
      if (repval < 1 or repval > len(labels)):
          logging.warning("Error, wrong number")
          continue
      return values[repval-1] 
      

'''      
   Pick files from a directory
'''
def selectFilesFromDirectory(directory, alreadySelected = None):
    DONE = ".....DONE....."
    RESTART = ".....RESTART....."
    dirfiles = os.listdir(directory)
    dirfiles.append(DONE)
    dirfiles.append(RESTART)
    selectedFiles = []

    if alreadySelected != None:
       selectedFiles = alreadySelected
       for a in selectedFiles:
           try:
              dirfiles.remove(a)
           except:
              print "Cannot remove " + a + " from " + str(dirfiles)
    while 1:
        question = "Current selection is: " + str(selectedFiles) + "\n\nPick file to select: "
        v = inputMenu("Select from directory", dirfiles, question=question, forceSelection = 0)
        if v == DONE or v==None:
            return selectedFiles
        elif v == RESTART:
            dirfiles = os.listdir(directory)
            dirfiles.append(DONE)
            dirfiles.append(RESTART)
            selectedFiles = []
        else:
            selectedFiles.append(v)
        dirfiles.remove(v)
        print "Currently selected: " + str(selectedFiles)

'''
  Input menu
'''
def test():
        #print inputMenu("Select from the list", ("Here", "We", "Are"))
        print selectFilesFromDirectory(".", ["MANIFEST.in"]) 
        
      